diff --git a/scanmem.c b/scanmem.c
index 584a4ff0..d35939a6 100644
--- a/scanmem.c
+++ b/scanmem.c
@@ -59,15 +59,37 @@ globals_t globals = {
     }
 };
 
+/* signal handler - Use async-signal-safe functions ONLY! */
 static void sighandler(int n)
 {
-    show_error("\nKilled by signal %d.\n", n);
-
-    if (globals.target) {
-        (void) detach(globals.target);
+    const char err_msg[] = "error: \nKilled by signal ";
+    const char msg_end[] = ".\n";
+    char number[4] = {0};
+    ssize_t n_size;
+    ssize_t wbytes;
+
+    wbytes = write(STDERR_FILENO, err_msg, sizeof(err_msg) - 1);
+    if (wbytes != sizeof(err_msg) - 1)
+        goto out;
+    /* manual int to str conversion */
+    if (n < 10) {
+        number[0] = (char) (0x30 + n);
+        n_size = 1;
+    } else if (n >= 100) {
+        goto out;
+    } else {
+        number[0] = (char) (0x30 + n / 10);
+        number[1] = (char) (0x30 + n % 10);
+        n_size = 2;
     }
-
-    exit(EXIT_FAILURE);
+    wbytes = write(STDERR_FILENO, &number, n_size);
+    if (wbytes != n_size)
+        goto out;
+    wbytes = write(STDERR_FILENO, msg_end, sizeof(msg_end) - 1);
+    if (wbytes != sizeof(msg_end) - 1)
+        goto out;
+out:
+    _exit(EXIT_FAILURE);   /* also detaches from tracee */
 }
 
 
